package com.template.controller;


import com.template.api.SmartAuthorityControllerAPI;
import com.template.common.utils.paramUtils;
import com.template.model.pojo.SmartAuthority;
import com.template.model.result.CommonResult;
import com.template.model.result.PageUtils;
import com.template.services.SmartAuthorityService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-12-04
 */
@RestController
public class SmartAuthorityController implements SmartAuthorityControllerAPI {

    @Autowired
    private SmartAuthorityService smartAuthorityService;

    /**
     * 新增权限管理
     * @param smartApply 权限管理数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult insertSmartAuthority(SmartAuthority smartApply, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartAuthorityService.insertSmartAuthority(smartApply);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新权限管理
     * @param sa 权限管理数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult updateSmartAuthorityById(SmartAuthority sa, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartAuthorityService.updateSmartAuthority(sa);
        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 权限管理分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageSmartAuthoritys(int currentPage, int pageCount, String name) {
        PageUtils<SmartAuthority> result = smartAuthorityService.queryPageSmartAuthoritys(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }


    @Override
    public CommonResult deleteSmartAuthorityById(int id) {

        SmartAuthority data = smartAuthorityService.getSmartById(id);

        if(data == null){
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = smartAuthorityService.deleteSmartAuthorityById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

